/*
 *
 *  Copyright (c) 2010 Steve Slaven
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
*/
package net.hoopajoo.android.SoftKeys;

import java.util.List;

import android.app.Activity;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.Spinner;

public class ConfigureExtra extends Activity implements OnClickListener {    
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.configure_extra);

        SharedPreferences settings = PreferenceManager.getDefaultSharedPreferences( this );

        List<CustomKey> items = CustomKey.getCustomKeyList();

        ArrayAdapter<CustomKey> adapter = new ArrayAdapter<CustomKey>( this, android.R.layout.simple_spinner_item, items );

        int i = 0;
        for( int id : new int[] { 
                    R.id.extra_custom1, R.id.extra_custom2,
                    R.id.extra_custom3, R.id.extra_custom4,
                    R.id.extra_custom5, R.id.extra_custom6                    
                } )  {
            i++;
            String pref_name = "service_extra_custom_keyid" + i;
            int keycode = Integer.parseInt( settings.getString( pref_name, "0" ) );

            Spinner s = (Spinner)findViewById( id );
            s.setAdapter( adapter );
            
            int idx = 0;
            for( CustomKey item : items ) {
                if( item.mId == keycode ) {
                    s.setSelection( idx );
                }
                idx++;
            }
        }
        
        findViewById( R.id.extra_modify_cancel ).setOnClickListener( this );
        findViewById( R.id.extra_modify_save ).setOnClickListener( this );
    }

    public void onClick( View v ) {
        if( v.getId() == R.id.extra_modify_save ) {
            SharedPreferences settings = PreferenceManager.getDefaultSharedPreferences( this );
            SharedPreferences.Editor e = settings.edit();
            int i = 0;
            for( int id : new int[] { 
                        R.id.extra_custom1, R.id.extra_custom2,
                        R.id.extra_custom3, R.id.extra_custom4,
                        R.id.extra_custom5, R.id.extra_custom6                    
                    } )  {
                i++;
                String pref_name = "service_extra_custom_keyid" + i;
                Spinner s = (Spinner)findViewById( id );
                CustomKey k = (CustomKey)s.getSelectedItem();
                e.putString( pref_name, Integer.toString( k.mId ) );
            }
            e.commit();
            ((Globals)getApplication()).restartService();
        }
        this.finish();
    }
}
